/*
	Tutorial Creare un videogioco con Irrlicht by softgame.it
	Parte 3

	Il seguente listato di codice  utilizzato nell'articolo presente su softgame.it al seguente indirizzo:
	http://www.softgame.it/index.php/creare-un-videogioco-3-irrlicht-struttura-base-e-panoramica

*/

#include "irrlicht.h"
using namespace irr;

#pragma comment(lib, "irrlicht.lib")

 int main()
 {
    // inizializzo il device impostando risoluzione 1024x720 usando DirectX9
    IrrlichtDevice *device = createDevice(video::EDT_DIRECT3D9,
        core::dimension2d<u32>(1024,720));

	// Creo driver
    video::IVideoDriver* driver = device->getVideoDriver();

	// Creo il gestore di scena
    scene::ISceneManager* scenemgr = device->getSceneManager();

	// Tramite il device imposto il titolo della finestra
    device->setWindowCaption(L"Irrlicht tutorial by softgame.it");

    // Aggiungo alla scena la mesh
		scene::ISceneNode* node = scenemgr->addMeshSceneNode(scenemgr->getMesh("take.x"));

    // Se caricata correttamente la mesh procedo al caricamento della texture e
	// disabilito il lighting *1, setto la posizione di partenza a -100 per ogni asse
    if (node)
    {
        node->setMaterialTexture(0, driver->getTexture("milwalll.bmp"));
        node->setMaterialFlag(video::EMF_LIGHTING, false);
		node->setPosition(core::vector3df(-100, -100, -100));
    }

    // Aggiungo una camera di tipo FPS (si controlla tramite mouse e frecce)
	// Gli indico il target da inquadrare con le coord.
    scenemgr->addCameraSceneNodeFPS();
	scenemgr->getActiveCamera()->setTarget(core::vector3df(-100, -100, -100));

    // Ciclo principale dove viene renderizzata la scena
    while(device->run() && driver)
    {
        driver->beginScene(true, true, video::SColor(255,0,0,255));
        scenemgr->drawAll();
        driver->endScene();
    }

    // Cancello il device prima di uscire
    device->drop();
    return 0;
	
 }